﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public enum DireccionH { Izquierda, Derecha }

public class matar : MonoBehaviour
{

    // Es la velocidad a la que se moverá la plataforma en el eje horizontal.
    public float VelocidadH = 0.3F;
    // Indica el sentido horizontal al que comenzará a moverse la plataforma.
    public DireccionH SentidoH = DireccionH.Derecha;
    public float MaxRecorridoPingPong = 5.0F;



    private Transform PlatformTransform;
    private float WalkedDistanceH = 0.0F;
    private float ReferencePingPongHPosition;
    private Vector3 InitialPlatformPosition;


    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.gameObject.CompareTag("Player"))
        {
            other.gameObject.SetActive(false);


        }
    }


    // Use this for initialization
    void Start()
    {
        PlatformTransform = transform;

        // Guardamos la posición inicial de la plataforma
        InitialPlatformPosition = PlatformTransform.position;

        // Inicializamos la posición de referencia para el cálculo de rebote horizontal (ping-pong)
        ReferencePingPongHPosition = PlatformTransform.position.x;

    }

    // Update is called once per frame
    void Update()
    {
        // Calculamos la distancia horizontal recorrida desde el último rebote
        WalkedDistanceH = Mathf.Abs(PlatformTransform.position.x - ReferencePingPongHPosition);
        if (MaxRecorridoPingPong != -1 && WalkedDistanceH >= MaxRecorridoPingPong)
        {
            // Si la función de Ping-Pong esta activada y se ha hecho el máximo recorrido en horizontal, la plataforma cambia de sentido
            if (SentidoH == DireccionH.Izquierda)
            {
                SentidoH = DireccionH.Derecha;
            }
            else
            {
                SentidoH = DireccionH.Izquierda;
            }

            // Actualizamos la posición horizontal de referencia para el cálculo de rebote horizontal (ping-pong)
            ReferencePingPongHPosition = PlatformTransform.position.x;
        }
        // Configuramos el sentido del movimiento horizontal
        if (SentidoH == DireccionH.Izquierda)
        {
            VelocidadH = -Mathf.Abs(VelocidadH);
        }
        else
        {
            VelocidadH = Mathf.Abs(VelocidadH);
        }
        // Movemos la plataforma
        PlatformTransform.Translate(new Vector3(VelocidadH, 0, 0) * Time.deltaTime);
    }
}